"use strict";function init(e,t){_generator=e,_logger=t}function analyzeLayer(e,t,r,a){_layerInProgress=utils.stripPrefix(t.name),_logger.log(t.id+", "+t.name+", "+t.type);var o=e.resolution,n=determineBounds(t,a),i=calculateSize(n,r);if(!isNaN(i.height)&&i.height<=0||!isNaN(i.width)&&i.width<=0)return void _logger.log("skipping layer, outside bounds:",i);var l=parseLayerOpacity(t.blendOptions),s=parseEffects(t);if(t.hasOwnProperty("fill"))if("solidColorLayer"===t.fill["class"])s.fills.unshift(parseColorFillEffect(t.fill));else if("gradientLayer"===t.fill["class"]){var c=parseGradientEffect(t.fill);c&&s.fills.unshift(c)}var u=t.hasOwnProperty("blendOptions")?parseBlendMode(t.blendOptions):void 0,g=t.hasOwnProperty("text")?parseTextStyle(t,l,o):{},d=t.hasOwnProperty("path")?parseBorderRadius(t):void 0,h=utils.stripPrefix(t.name);return 0==h.length&&(h="Untitled"),{name:h,originalName:t.name,sourceId:t.id+"",blendMode:u,opacity:l,type:determineLayerType(t.type),fontFace:g.fontFace,fontSize:g.fontSize,textAlign:g.align,color:g.color,content:g.content,letterSpacing:g.letterSpacing,lineHeight:g.lineHeight,textStyles:g.styles,rect:i,fills:s.fills,borders:s.borders,borderRadius:d,shadows:s.shadows,exportable:utils.isExported(t),bounds:n}}function determineBounds(e,t){var r=_generator.getDeepBounds(e);if(t)for(var a=0;a<t.length;a++)if(t[a].ids.indexOf(e.id)>-1){r=intersectBounds(r,t[a].bounds);break}return r}function intersectBounds(e,t){return{top:Math.max(e.top,t.top),left:Math.max(e.left,t.left),bottom:Math.min(e.bottom,t.bottom),right:Math.min(e.right,t.right)}}function parseLayerOpacity(e){var t=1;return e&&(t=opacitySafe(e)),t}function parseBorderRadius(e){if(e.path.hasOwnProperty("pathComponents"))for(var t=0;t<e.path.pathComponents.length;t++)if(e.path.pathComponents[t].hasOwnProperty("origin")&&"roundedRect"===e.path.pathComponents[t].origin.type&&e.path.pathComponents[t].origin.hasOwnProperty("radii")){var r=e.path.pathComponents[t].origin.radii;return checkIfAllSame(r)}}function checkIfAllSame(e){if(0!==e.length){for(var t=0;t<e.length;t++)if(e[t]!==e[0])return;return e[0]}}function pixelValue(e,t){if(!(e instanceof Object))return e;switch(e.units){case"pointsUnit":return Math.round(ptToPx(e.value,t));default:return e.value}}function ptToPx(e,t){return e*t/72}function parseFontStyle(e,t,r,a){var o=[];return e.forEach(function(e){var n,i=e.textStyle,l=pixelValue(i.size,r)*a;n=i.fontPostScriptName?i.fontPostScriptName:i.fontName+" "+i.fontStyleName;var s={r:0,g:0,b:0,a:t};i.hasOwnProperty("color")&&(s={r:Math.round(i.color.red||0),g:Math.round(i.color.green||0),b:Math.round(i.color.blue||0),a:t});var c;i.hasOwnProperty("tracking")&&(c=l*i.tracking/1e3);var u;i.hasOwnProperty("leading")&&(u=pixelValue(i.leading,r)*a),o.push({range:{from:e.from,to:e.to},style:{fontSize:l,fontFace:n,color:s,letterSpacing:c,lineHeight:u}})}),o}function parseParagraphStyle(e,t,r){for(var a=0;a<e.length;a++){for(var o,n,i=0;i<t.length;i++)if(o||e[a].range.from>=t[i].from&&(o=i),!n&&e[a].range.to<=t[i].to){n=i;break}if(o!=n)for(var l=e[a].range.to,i=o;i<=n;i++)if(i==o)e[a].range.to=t[i].to,e[a].range.location=e[a].range.from,e[a].range.length=r.substring(e[a].range.from,e[a].range.to).trim().length,e[a].style.textAlign=parseTextAlign(t[i].paragraphStyle.align);else{var s=JSON.parse(JSON.stringify(e[a]));s.range.from=t[i].from,i==n?s.range.to=l:s.range.to=t[i].to,s.range.location=s.range.from,s.range.length=r.substring(s.range.from,s.range.to).trim().length,s.style.textAlign=parseTextAlign(t[i].paragraphStyle.align),e.splice(a+1,0,s),a++}else e[a].range.location=e[a].range.from,e[a].range.length=r.substring(e[a].range.from,e[a].range.to).trim().length,e[a].style.textAlign=parseTextAlign(t[o].paragraphStyle.align)}}function filterDuplicateTextStyles(e){var t=[];if(e&&e.length>0){t.push(e[0]);for(var r=1;r<e.length;r++)e[r].from==e[r-1].from&&e[r].to==e[r-1].to?_logger.log("detected duplicate text style.. skipping.."):t.push(e[r])}return t}function parseTextStyle(e,t,r){var a=1;e.text.hasOwnProperty("transform")&&(a=e.text.transform.yy);var o=e.text.textKey,n=parseFontStyle(filterDuplicateTextStyles(e.text.textStyleRange),t,r,a);parseParagraphStyle(n,e.text.paragraphStyleRange,o);var i,l=e.text.paragraphStyleRange[0].paragraphStyle;l.hasOwnProperty("align")&&(i=parseTextAlign(l.align));var s=n[0].style;return mergeIdenticalStyles(n,o),_logger.log("finalStyles:",n),{align:i,content:o,fontFace:s.fontFace,fontSize:s.fontSize,color:s.color,lineHeight:s.lineHeight,letterSpacing:s.letterSpacing,styles:n}}function mergeIdenticalStyles(e,t){for(var r=0;r<e.length-1;r++)isIdenticalStyle(e[r],e[r+1])&&(e[r].range.to=e[r+1].range.to,e[r].range.length=t.substring(e[r].range.from,e[r].range.to).trim().length,e.splice(r+1,1),r--)}function isIdenticalStyle(e,t){return e.style.fontSize==t.style.fontSize&&e.style.fontFace==t.style.fontFace&&e.style.lineHeight==t.style.lineHeight&&e.style.textAlign==t.style.textAlign&&e.style.letterSpacing==t.style.letterSpacing&&isIdenticalColor(e.style.color,t.style.color)}function isIdenticalColor(e,t){return e&&t&&e.a==t.a&&e.r==t.r&&e.g==t.g&&e.b==t.b}function parseTextAlign(e){return e&&e.indexOf("justify")!==-1?"justify":e}function parseEffects(e){var t=[],r=[],a=[];if(e.hasOwnProperty("layerEffects")){var o=e.layerEffects;if(o.hasOwnProperty("dropShadow")&&(_logger.log("has dropShadow"),o.dropShadow.enabled)){var n=parseShadowEffect(o.dropShadow,"outer");r.push(n)}if(o.hasOwnProperty("dropShadowMulti")&&(_logger.log("has dropShadowMulti"),o.dropShadowMulti.forEach(function(e){if(e.enabled){var t=parseShadowEffect(e,"outer");r.push(t)}})),o.hasOwnProperty("innerShadow")&&(_logger.log("has innerShadow"),o.innerShadow.enabled)){var n=parseShadowEffect(o.innerShadow,"inner");r.push(n)}if(o.hasOwnProperty("innerShadowMulti")&&(_logger.log("has innerShadowMulti"),o.innerShadowMulti.forEach(function(e){if(e.enabled){var t=parseShadowEffect(e,"inner");r.push(t)}})),o.hasOwnProperty("outerGlow")&&_logger.log("has outerGlow"),o.hasOwnProperty("bevelEmboss")&&_logger.log("has bevelEmboss"),o.hasOwnProperty("chromeFX")&&_logger.log("has chromeFX"),o.hasOwnProperty("solidFill")&&(_logger.log("has solidFill"),o.solidFill.enabled)){var i=parseColorFillEffect(o.solidFill);t.unshift(i)}if(o.hasOwnProperty("solidFillMulti")&&(_logger.log("has solidFillMulti"),o.solidFillMulti.forEach(function(e){if(e.enabled){var r=parseColorFillEffect(e);t.unshift(r)}})),o.hasOwnProperty("patternFill")&&_logger.log("has patternFill"),o.hasOwnProperty("gradientFill")&&(_logger.log("has gradientFill"),o.gradientFill.enabled)){var i=parseGradientEffect(o.gradientFill);i&&t.unshift(i)}if(o.hasOwnProperty("gradientFillMulti")&&(_logger.log("has gradientFillMulti"),o.gradientFillMulti.forEach(function(e){if(e.enabled){var r=parseGradientEffect(e);r&&t.unshift(r)}})),o.hasOwnProperty("frameFX")&&(_logger.log("has frameFX"),o.frameFX.enabled)){var l=parseBorderEffect(o.frameFX);l&&a.push(l)}o.hasOwnProperty("frameFXMulti")&&(_logger.log("has frameFXMulti"),o.frameFXMulti.forEach(function(e){if(e.enabled){var t=parseBorderEffect(e);t&&a.push(t)}}))}if(e.hasOwnProperty("strokeStyle")&&(_logger.log("has strokeStyle"),1==e.strokeStyle.strokeEnabled)){var l=parseStrokeEffect(e.strokeStyle);l&&a.push(l)}return{fills:t,borders:a,shadows:r}}function parseBlendMode(e){if(e.hasOwnProperty("mode")){var t=e.mode;switch(t){case"darken":return"darken";case"multiply":return"multiply";case"colorBurn":return"color-burn";case"lighten":return"lighten";case"screen":return"screen";case"colorDodge":return"color-dodge";case"overlay":return"overlay";case"softLight":return"soft-light";case"hardLight":return"hard-light";case"difference":return"difference";case"exclusion":return"exclusion";case"hue":return"hue";case"saturation":return"saturation";case"color":return"color";case"luminosity":return"luminosity";default:return"normal"}}}function parseColorFillEffect(e){var t={},r=opacitySafe(e);return t.color={r:Math.round(e.color.red||0),g:Math.round(e.color.green||0),b:Math.round(e.color.blue||0),a:r},t.opacity=r,t.fillType="color",t.blendMode=parseBlendMode(e),t}function parseGradientEffect(e){var t=parseGradientObject(e);if(t)return{gradient:t,opacity:opacitySafe(e),fillType:"gradient",blendMode:parseBlendMode(e)}}function parseStrokeEffect(e){var t={};if(t.opacity=opacitySafe(e.strokeStyleOpacity),e.strokeStyleLineWidth.hasOwnProperty("value")?t.thickness=e.strokeStyleLineWidth.value:t.thickness=e.strokeStyleLineWidth,t.position=parseStrokePosition(e.strokeStyleLineAlignment),e.strokeStyleContent.hasOwnProperty("color"))t.fillType="color",t.color={r:Math.round(e.strokeStyleContent.color.red||0),g:Math.round(e.strokeStyleContent.color.green||0),b:Math.round(e.strokeStyleContent.color.blue||0),a:t.opacity};else{if(!e.strokeStyleContent.hasOwnProperty("gradient"))return;t.fillType="gradient",t.gradient=parseGradientObject(e.strokeStyleContent)}return t.blendMode=parseBlendMode(e.strokeStyleBlendMode),t}function parseStrokePosition(e){switch(e){case"strokeStyleAlignInside":return"inside";case"strokeStyleAlignCenter":return"center";case"strokeStyleAlignOutside":return"outside";default:_logger.log("unknown stroke style alignment: ",e)}}function parseBorderEffect(e){var t={};if(t.opacity=opacitySafe(e),t.thickness=e.size,t.position=parseBorderPosition(e.style),t.fillType=parseBorderFillType(e.paintType),"color"===t.fillType)t.color={r:Math.round(e.color.red||0),g:Math.round(e.color.green||0),b:Math.round(e.color.blue||0),a:t.opacity};else{if("gradient"!==t.fillType)return;var r=parseGradientObject(e);if(!r)return;t.gradient=r}return t.blendMode=parseBlendMode(e),t}function parseShadowEffect(e,t){var r={},a=opacitySafe(e);r.color={r:Math.round(e.color.red||0),g:Math.round(e.color.green||0),b:Math.round(e.color.blue||0),a:a},r.opacity=a,r.spread=e.blur*e.chokeMatte/100,r.blurRadius=e.blur-r.spread;var o=calculateShadowOffset(e);return r.offsetX=o.x,r.offsetY=o.y,r.type=t,r.blendMode=parseBlendMode(e),r}function calculateShadowOffset(e){var t;return t=e.useGlobalAngle===!0?_globalLight.angle:e.localLightingAngle.value,{x:Math.cos(toRadian(t))*e.distance,y:Math.sin(toRadian(t))*e.distance}}function toRadian(e){return(180-e)*Math.PI/180}function parseGradientObject(e){var t=1;e.hasOwnProperty("scale")&&(t=e.scale.value);var r=parseGradientType(e.type);if(r)return{to:{x:0,y:0},from:{x:0,y:0},angle:e.angle.value,scale:t,type:r,colorStops:calculateColorStops(e.gradient)}}function parseGradientType(e){switch(e){case"linear":return"linear";case"angle":return"angular";case"radial":return"radial";default:_logger.log("unknown gradient type: ",e)}}function parseBorderFillType(e){switch(e){case"solidColor":return"color";case"gradientFill":return"gradient";default:_logger.log("unknown paint type: ",e)}}function parseBorderPosition(e){switch(e){case"insetFrame":return"inside";case"outsetFrame":return"outside";case"centeredFrame":return"center";default:_logger.log("unknown border style: ",e)}}function calculateColorStops(e){var t=[],r=4096,a=e.colors,o=e.transparency;return a.forEach(function(e){var a=calculateAlpha(e.location,o);t.push({color:{r:Math.round(e.color.red||0),g:Math.round(e.color.green||0),b:Math.round(e.color.blue||0),a:a},position:e.location/r})}),t}function calculateAlpha(e,t){var r,a=findTransparencyRange(e,t);if(2===a.length){var o=a[1].location-a[0].location,n=a[1].opacity.value-a[0].opacity.value,i=0!==o?n/o:0,l=e-a[0].location;r=(a[0].opacity.value+i*l)/100}return void 0==r&&(r=1),r}function findTransparencyRange(e,t){for(var r=[],a=0;a<t.length;a++){if(t[a].location===e){r[0]=t[a],r[1]=t[a];break}if(t[a].location>e){0===a?r[0]=t[a]:r[0]=t[a-1],r[1]=t[a];break}}return r}function opacitySafe(e){var t=1;return e.hasOwnProperty("opacity")&&(t=e.opacity.value/100),t}function determineLayerType(e){return"textLayer"===e?"text":"shape"}function calculateSize(e,t){var r=e;t&&(r={top:Math.max(e.top,t.top),left:Math.max(e.left,t.left),bottom:Math.min(e.bottom,t.bottom),right:Math.min(e.right,t.right)});var a=toSize(r);return t?intersectRect(a,toSize(t)):a}function toSize(e){return{y:e.top,height:e.bottom-e.top,x:e.left,width:e.right-e.left}}function intersectRect(e,t){return{y:Math.max(0,e.y-t.y),height:Math.min(e.height,t.height),x:Math.max(0,e.x-t.x),width:Math.min(e.width,t.width)}}function extractLayers(e,t,r,a){var o=[],n=[];return t.layers&&t.layers.forEach(function(t){if(t.visible)if(utils.isLayerGroup(t.type)){var i=findMaskBounds(t);if(utils.isSkipped(t)){var l=analyzeLayer(e,t,r,i);l&&(l.exportable&&n.push({id:l.sourceId,name:l.originalName,pixels:hasBitmapLayer(t.layers,e)}),delete l.bounds,o.push(l))}else{var s=extractLayers(e,t,r,i);if(o=o.concat(s.parsedLayers),n=n.concat(s.assets),utils.isExported(t)){var l=analyzeLayer(e,t,r,i);l&&(l.exportable&&n.push({id:l.sourceId,name:l.originalName,bounds:l.bounds,pixels:hasBitmapLayer(t.layers,e)}),delete l.bounds,o.push(l))}}}else if(!utils.isExported(t)&&t.hasOwnProperty("smartObject")){_logger.log("has smartObject");var c=findSmartObject(e,t.smartObject.ID);if(c){fixSmartObjectBounds(t.smartObject.transform,c,t.bounds);var i=findMaskBounds(c),s=extractLayers(c,c,r,i);o=o.concat(s.parsedLayers)}var l=analyzeLayer(e,t,r,a);l&&(l.exportable&&n.push({id:l.sourceId,name:l.originalName,pixels:t.pixels||hasBitmapLayer(c.layers,e)}),delete l.bounds,o.push(l))}else{var u,g;if(t.hasOwnProperty("smartObject")){var c=findSmartObject(e,t.smartObject.ID);c&&(u=c.fileType,g=hasBitmapLayer(c.layers,e))}var l=analyzeLayer(e,t,r,a);l&&(l.exportable&&n.push({id:l.sourceId,name:l.originalName,smartObjectFileType:u,pixels:t.pixels||g}),delete l.bounds,o.push(l))}}),{parsedLayers:o,assets:n}}function hasBitmapLayer(e,t){if(e)for(var r=0;r<e.length;r++){if(1==e[r].pixels)return!0;if(e[r].layers&&hasBitmapLayer(e[r].layers,t))return!0;if(e[r].hasOwnProperty("smartObject")){var a=findSmartObject(t,e[r].smartObject.ID);if(a&&hasBitmapLayer(a.layers,t))return!0}}return!1}function findSmartObject(e,t){if(t&&e.placed)for(var r=0;r<e.placed.length;r++)if(e.placed[r].placedID===t)return e.placed[r]}function fixSmartObjectBounds(e,t,r){var a={top:e[1],left:e[0],right:e[2],bottom:e[7]};_logger.log("layerBounds:",a);var o=t.bounds;_logger.log("smartObjectBounds:",o);var n={h:(a.bottom-a.top)/(o.bottom-o.top),w:(a.right-a.left)/(o.right-o.left)};if(_logger.log("ratio:",n),isFinite(n.h)&&isFinite(n.w)){var i=a.top,l=a.left;t.hasOwnProperty("layers")&&t.layers.forEach(function(e){fixSmartLayerBounds(l,i,e,n,r)})}}function fixSmartLayerBounds(e,t,r,a,o){var n={top:Math.round(t+r.bounds.top*a.h),left:Math.round(e+r.bounds.left*a.w),bottom:Math.round(t+r.bounds.bottom*a.h),right:Math.round(e+r.bounds.right*a.w)};o&&(n={top:Math.max(n.top,o.top),left:Math.max(n.left,o.left),bottom:Math.min(n.bottom,o.bottom),right:Math.min(n.right,o.right)}),r.bounds=n,r.hasOwnProperty("layers")&&r.layers.forEach(function(r){fixSmartLayerBounds(e,t,r,a,o)})}function findMaskBounds(e){var t=[],r=[];if(e.layers)for(var a=0;a<e.layers.length;a++)e.layers[a].clipped===!0?r.push(e.layers[a].id):r.length>0&&(t.push({ids:clone([],r),bounds:e.layers[a].bounds}),r=[]);var o=t.length,n=t.reduce(function(e,t){return e+t.ids.length},0);return e.layers&&n+o===e.layers.length&&t.forEach(function(t){t.ids.push(e.id)}),t}function parseArtBoard(e,t,r){_globalLight=e.globalLight;var a;_logger.log("shouldParseGrid:",r),1==r&&(a=parseGrid(e.guides,t.bounds),_logger.log("grid:",a));var o=calculateSize(t.bounds),n=extractLayers(e,t,t.bounds);return _globalLight=void 0,_layerInProgress=void 0,{name:t.name,sourceId:t.id+"",height:o.height,width:o.width,rect:o,layers:n.parsedLayers.sort(sortByArea),assets:n.assets,grid:convertToZeplinGrid(a),psLayer:t}}function sortByArea(e,t){return t.rect.height*t.rect.width-e.rect.height*e.rect.width}function sortByPosition(e,t){return e.coordinate-t.coordinate}function parseVerticalGrid(e){if(_logger.log("vertical.length:",e.length),e.length>1){var t,r,a=Math.floor(e.length/2);e=e.sort(sortByPosition);for(var o=0;o<e.length-1;o++){var n=e[o+1].coordinate-e[o].coordinate;if(o%2==0)if(r){if(r!==n)return void _logger.log("invalid column width.. columnWidth:",r," value:",n)}else r=n;else if(t){if(t!==n)return void _logger.log("invalid column gutter.. gutter:",t," value:",n)}else t=n}if(t&&r&&a)return{gutter:t,columnWidth:r,columnCount:a}}}function parseHorizontalGrid(e){if(_logger.log("horizontal.length:",e.length),e.length>1){var t,r,a=Math.floor(e.length/2);e=e.sort(sortByPosition);for(var o=0;o<e.length-1;o++){var n=e[o+1].coordinate-e[o].coordinate;if(o%2==0)if(r){if(r!==n)return void _logger.log("invalid row height.. rowHeight:",r," value:",n)}else r=n;else if(t){if(t!==n)return void _logger.log("invalid row gutter.. gutter:",t," value:",n)}else t=n}if(t&&r&&a)return{gutter:t,rowHeight:r,rowCount:a}}}function parseGrid(e,t){var r={vertical:[],horizontal:[]};e&&e.forEach?e.forEach(function(e){e.direction.indexOf("VERTICAL")!=-1&&t.left<=e.coordinate&&t.right>=e.coordinate?r.vertical.push(e):t.top<=e.coordinate&&t.bottom>=e.coordinate&&r.horizontal.push(e)}):_logger.log("error with guides:",e);var a=calculateMargins(t,r),o=parseHorizontalGrid(r.horizontal),n=parseVerticalGrid(r.vertical);return{horizontal:o,vertical:n,margins:a}}function calculateMargins(e,t){var r=0,a=0,o=0,n=0;return t.horizontal.length>0&&(r=t.horizontal[0].coordinate-e.top,a=e.bottom-t.horizontal[t.horizontal.length-1].coordinate),t.vertical.length>0&&(o=t.vertical[0].coordinate-e.left,n=e.right-t.vertical[t.vertical.length-1].coordinate),{top:r,left:o,bottom:a,right:n}}function convertToZeplinGrid(e){if(e&&(e.horizontal||e.vertical)){var t,r;return e.vertical&&(t={columnWidth:e.vertical.columnWidth,numberOfCols:e.vertical.columnCount,gutterWidth:e.vertical.gutter,guttersOnOutside:!1}),e.horizontal&&(r={rowHeight:e.horizontal.rowHeight,gutterHeight:e.horizontal.gutter}),{horizontalOffset:e.margins.left,vertical:t,horizontal:r}}}var utils=require("./utils"),clone=require("object-assign"),_globalLight,_layerInProgress,_generator,_logger;module.exports={init:init,getLayerInProgress:function(){return _layerInProgress},parseArtBoard:parseArtBoard};