"use strict";function checkPrefix(e,t){var n=e.match(PREFIX_REGEX),r=!1;if(null!==n)for(var o=n[1].split(""),i=0;i<o.length;i++)if(o[i]===t){r=!0;break}return r}function isExportable(e){return!checkPrefix(e.name,EXPORT_FLAG)}function isExported(e){return checkPrefix(e.name,EXPORT_FLAG)}function isSkipped(e){return isLayerGroup(e.type)&&checkPrefix(e.name,SKIP_FLAG)}function isSkippable(e){return isLayerGroup(e.type)&&!checkPrefix(e.name,SKIP_FLAG)}function isLayerGroup(e){return"layerSection"===e}function isArtboard(e){return isLayerGroup(e.type)&&e.hasOwnProperty("artboard")}function getZeplinTempDir(){return getTempDir()+BUNDLE_ID+"/"}function getTempDir(){var e=os.tmpdir();return"/"!==e.slice(-1)&&(e+="/"),e}function stringify(e){try{return JSON.stringify(e,null,"    ")}catch(t){console.error(t)}return String(e)}function checkPathCreateIfNotExists(e){var t=path.dirname(e),n=(new Date).getTime();try{fs.lstatSync(t)}catch(r){mkdirp.sync(t)}console.log("path created in",(new Date).getTime()-n,"ms")}function saveFileToDisk(e,t){checkPathCreateIfNotExists(e);var n=(new Date).getTime(),r=fs.createWriteStream(e);r.once("open",function(e){r.write(t),r.end(),console.log("file saved in",(new Date).getTime()-n,"ms")})}function stripPrefix(e){var t=e.match(PREFIX_REGEX);return null!==t?t[2]:e}function getLayerType(e){return isArtboard(e)?"artboard":isLayerGroup(e.type)?"layerSection":"layer"}function inspectExecution(e,t,n){console.log("stdout: "+t),console.log("stderr: "+n),null!==e&&console.log("exec error: "+e)}function openZeplin(e){switch(e&&(e=path.resolve(e)),getOsType()){case"mac":e?exec("open -b "+BUNDLE_ID+" "+e,inspectExecution):exec("open -b "+BUNDLE_ID,inspectExecution);break;case"win":fs.existsSync(path.resolve(process.env.LOCALAPPDATA+"\\Zeplin\\Update.exe"))?e?exec('"%LOCALAPPDATA%\\Zeplin\\Update.exe" --processStart=Zeplin.exe -a "--export '+e+'"',inspectExecution):exec('"%LOCALAPPDATA%\\Zeplin\\Update.exe" --processStart=Zeplin.exe',inspectExecution):(console.log("process not found under LOCALAPPDATA, falling back to PROGRAMDATA.."),e?exec('"%PROGRAMDATA%\\%USERNAME%\\Zeplin\\Update.exe" --processStart=Zeplin.exe -a "--export '+e+'"',inspectExecution):exec('"%PROGRAMDATA%\\%USERNAME%\\Zeplin\\Update.exe" --processStart=Zeplin.exe',inspectExecution));break;default:console.log("unknown platform")}}function findProxy(){var e,t=Q.defer();switch(getOsType()){case"mac":e="echo $HTTP_PROXY";break;case"win":e="echo %HTTP_PROXY%";break;default:t.reject("invalid os type..")}return exec(e,function(e,n){if(e)console.log("HTTP_PROXY could not be fetched..",e),t.reject();else{var r=n.trim();"win"==getOsType()&&"%HTTP_PROXY%"==r?t.resolve():t.resolve(r)}}),t.promise}function setPhotoshopVersion(e){psVersion=e}function getPhotoshopVersion(){return psVersion}function setPluginVersion(e){pluginVersion=e}function getPluginVersion(){return pluginVersion}function setAppPath(e){switch(getOsType()){case"mac":appPath=e;break;case"win":var t=e.split("/").filter(function(e){return e});t[0]=t[0]+":\\",appPath=path.resolve.apply(null,t)}console.log("appPath is defined:",appPath)}function getAppPath(){return appPath}function getGeneratorPluginPath(){return path.resolve(appPath+GENERATOR_PATH)}function getPanelPath(){switch(getOsType()){case"mac":return homedir()+"/Library/Application Support/Adobe/CEP/extensions";case"win":return homedir()+"\\AppData\\Roaming\\Adobe\\CEP\\extensions";default:console.log("unknown platform")}}function getOsType(){return"darwin"===os.platform()?"mac":"win32"===os.platform()?"win":void console.log("invalid os type:",os.platform())}function calculatePadding(e,t){return{top:e.top-t.top,left:e.left-t.left,bottom:t.bottom-e.bottom,right:t.right-e.right}}function getToken(){var e,t=Q.defer();switch(getOsType()){case"mac":e=path.resolve(homedir()+"/Library/Application Support/"+BUNDLE_ID+"/zt");break;case"win":e=path.resolve(homedir()+"/AppData/Roaming/Zeplin/zt");break;default:return console.log("unknown platform"),void t.reject("unknown platform")}return fs.readFile(e,{encoding:"utf8"},function(e,n){return e?void t.reject(e):void t.resolve(n.trim())}),t.promise}function assetFactors(e,t){switch(e){case"android":switch(t){case"mdpi":return{png:["1000","1500","2000","3000","4000"],svg:["1000"]};case"hdpi":return{png:["1000","0666","1333","2000","2666"],svg:["1000"]};case"xhdpi":return{png:["1000","0500","0750","1500","2000"],svg:["1000"]};case"xxhdpi":return{png:["1000","0333","0500","0666","1333"],svg:["1000"]};case"xxxhdpi":return{png:["1000","0250","0375","0500","0750"],svg:["1000"]};default:console.log("unknown density",t)}break;case"ios":switch(t){case"1x":return{png:["1000","2000","3000"],pdf:["1000"]};case"2x":return{png:["1000","0500","1500"],pdf:["0500"]};case"3x":return{png:["1000","0333","0666"],pdf:["0333"]};default:console.log("unknown density",t)}break;case"web":switch(t){case"1x":return{png:["1000","2000","3000"],svg:["1000"]};case"2x":return{png:["1000","0500","1500"],svg:["1000"]};case"3x":return{png:["1000","0333","0666"],svg:["1000"]};default:console.log("unknown density",t)}break;case"osx":switch(t){case"1x":return{png:["1000","2000"],pdf:["1000"]};case"2x":return{png:["1000","0500"],pdf:["0500"]};default:console.log("unknown density",t)}break;default:console.log("unknown type",e)}}var path=require("path"),fs=require("fs"),os=require("os"),exec=require("child_process").exec,homedir=require("homedir"),mkdirp=require("mkdirp"),Q=require("q"),EXPORT_FLAG="e",SKIP_FLAG="g",API_URL="https://api.zeplin.io",PREFIX_REGEX="^-([a-z]+)-(.*)$",BUNDLE_ID="io.zeplin.osx",GENERATOR_PATH="/Plug-ins/Generator/",modelVersion=2,appPath,psVersion,pluginVersion;module.exports={API_URL:API_URL,EXPORT_FLAG:EXPORT_FLAG,SKIP_FLAG:SKIP_FLAG,V:modelVersion,stripPrefix:stripPrefix,isSkipped:isSkipped,isSkippable:isSkippable,isExported:isExported,isExportable:isExportable,isLayerGroup:isLayerGroup,isArtboard:isArtboard,getLayerType:getLayerType,checkPathCreateIfNotExists:checkPathCreateIfNotExists,saveFileToDisk:saveFileToDisk,getZeplinTempDir:getZeplinTempDir,getGeneratorPluginPath:getGeneratorPluginPath,getPanelPath:getPanelPath,setAppPath:setAppPath,getAppPath:getAppPath,stringify:stringify,inspectExecution:inspectExecution,openZeplin:openZeplin,getPhotoshopVersion:getPhotoshopVersion,setPhotoshopVersion:setPhotoshopVersion,getPluginVersion:getPluginVersion,setPluginVersion:setPluginVersion,calculatePadding:calculatePadding,getToken:getToken,assetFactors:assetFactors,getOsType:getOsType,findProxy:findProxy};